#ident "%W% %G%"

#include <linux/string.h>
#include <linux/fs.h>
#include <linux/slab.h> /* needed by putname macro */
#include <linux/sched.h> /* needed by current-> in __abi_trace() macro */
#include <linux/module.h>
#include <linux/personality.h>
#include <asm/uaccess.h>

#include "../include/util/trace.h"


#if defined(CONFIG_ABI_TRACE)
static void
print_string(char *buf, char *str)
{
	char *tmp;

	tmp = getname(str);
	if (!IS_ERR(tmp)) {
		/* we are debugging, we don't need to see it all */
		tmp[80] = '\0';
		sprintf(buf, "\"%s\"", tmp);
		putname(tmp);
	}
}

void plist(char *name, char *args, int *list)
{
	char buf[512], *p = buf;

	buf[0] = '\0';
	while (*args) {
		switch (*args++) {
		case 'd':
			sprintf(p, "%d", *list++);
			break;
		case 'o':
			sprintf(p, "0%o", *list++);
			break;
		case 'p':
			sprintf(p, "%p", (void *)(*list++));
			break;
		case '?':
		case 'x':
			sprintf(p, "0x%x", *list++);
			break;
		case 's':
			print_string(p, (char *)(*list++));
			break;
		default:
			sprintf(p, "?%c%c?", '%', args[-1]);
			break;
		}

		while (*p)
			++p;
		if (*args) {
			*p++ = ',';
			*p++ = ' ';
			*p = '\0';
		}
	}
	__abi_trace("%s(%s)\n", name, buf);
}
int
pdump(char __user *s, int l)
{
  char *p, buf[3072], c; int i, j, k;
  if (l<=0) return 0;
  if (l>1024) l = 1024;
  p=buf;
  for(i=0; i<l; i++) {
    /*get_user(c,s+i);*/ c=s[i];
    j = (c & 0xF0) >> 4;
    k = c & 0x0F;
    if (j>9) p[0] = 55 + j;
     else p[0] = 48 + j;
    if (k>9) p[1] = 55 + k;
     else p[1] = 48 + k;
    p[2]='.';
    p += 3;
   }
  p[0]='\0';
  i=printk("%s\n",buf); 
  return i;
}
u_int abi_trace_flg;

EXPORT_SYMBOL(plist);
EXPORT_SYMBOL(pdump);
EXPORT_SYMBOL(abi_trace_flg);

#endif /* CONFIG_ABI_TRACE */
